################################################################################
#
# Makefile  : Freetype / src
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/03/13 14:43:34 popineau>
#
################################################################################
root_srcdir=..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

USE_GNUW32 = 1
USE_ZLIB = 1
USE_FREETYPE = 1
MAKE_FREETYPE = 1

!include <make/common.mak>

{../build/win32}.c{$(objdir)}.obj:
	$(compile) $<

{autohint}.c{$(objdir)}.obj:
	$(compile) $<

{cff}.c{$(objdir)}.obj:
	$(compile) $<

{base}.c{$(objdir)}.obj:
	$(compile) $<

{pcf}.c{$(objdir)}.obj:
	$(compile) $<

{psaux}.c{$(objdir)}.obj:
	$(compile) $<

{pshinter}.c{$(objdir)}.obj:
	$(compile) $<

{psnames}.c{$(objdir)}.obj:
	$(compile) $<

{raster}.c{$(objdir)}.obj:
	$(compile) $<

{sfnt}.c{$(objdir)}.obj:
	$(compile) $<

{smooth}.c{$(objdir)}.obj:
	$(compile) $<

{truetype}.c{$(objdir)}.obj:
	$(compile) $<

{type1}.c{$(objdir)}.obj:
	$(compile) $<

{cid}.c{$(objdir)}.obj:
	$(compile) $<

{winfonts}.c{$(objdir)}.obj:
	$(compile) $<

programs = $(freetypedll)
libfiles = $(freetypelib)
includefiles = 
manfiles =
objects = \
	$(objdir)\ftdebug.obj	\
	$(objdir)\autohint.obj	\
	$(objdir)\cff.obj	\
	$(objdir)\ftbase.obj	\
	$(objdir)\ftglyph.obj	\
	$(objdir)\ftinit.obj	\
	$(objdir)\ftmm.obj	\
	$(objdir)\ftsystem.obj	\
	$(objdir)\pcf.obj	\
	$(objdir)\psaux.obj	\
	$(objdir)\pshinter.obj	\
	$(objdir)\psmodule.obj	\
	$(objdir)\raster.obj	\
	$(objdir)\sfnt.obj	\
	$(objdir)\smooth.obj	\
	$(objdir)\truetype.obj	\
	$(objdir)\type1.obj	\
	$(objdir)\type1cid.obj	\
	$(objdir)\winfnt.obj

default: all

all: $(objdir) $(freetype)

lib: $(objdir) $(freetypelib)

!ifdef FREETYPE_DLL
DEFS = $(DEFS) -DMAKE_FREETYPE_DLL

$(freetypelib):  $(objects)
	$(archive) /DEF $(objects)

$(freetypedll): $(objects) $(gnuw32lib)
	$(link_dll) $(objects) $(objdir)\freetype.exp $(conlibs) $(gnuw32lib)
!else
$(freetypelib): $(objects)
	$(archive) $(objects)
!endif

!include <make/config.mak>
!include <make/install.mak>

install:: install-exec install-lib install-include

!include <make/clean.mak>

!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End:
