################################################################################
#
# Makefile  : GetUrl
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/03/19 10:17:24 popineau>
#
################################################################################
root_srcdir = ..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

USE_GETURL = 1
MAKE_GETURL = 1
USE_NETWORK = 1
# USE_CURL = 1

!include <make/common.mak>

DEFS = $(DEFS) -DWIN32_NATIVE

objects = \
	$(objdir)\geturl.obj \
	$(objdir)\dialog.obj \
	$(objdir)\msg.obj \
	$(objdir)\netio.obj \
	$(objdir)\nio-file.obj \
	$(objdir)\nio-ftp.obj \
	$(objdir)\nio-http.obj \
	$(objdir)\nio-ie5.obj \
!ifdef USE_WWW
	$(objdir)\nio-libwww.obj \
!endif
!ifdef USE_CURL
	$(objdir)\nio-libcurl.obj \
!endif
	$(objdir)\simpsock.obj
programs = $(geturldll)
libfiles = $(geturllib)

!ifdef USE_WWW
DEFS = $(DEFS) -DUSE_WWW
!endif

!ifdef USE_CURL
DEFS = $(DEFS) -DUSE_CURL
!endif


#
# Main target
#
default: all

all: $(objdir) $(geturl) $(objdir)\geturl_test.exe

lib: $(objdir) $(geturllib)

!ifdef GETURL_DLL

DEFS = $(DEFS) -DMAKE_GETURL_DLL

$(geturllib): $(objdir) $(objects)
	$(archive) /DEF $(objects)

$(geturldll): $(objects) # $(objdir)\geturl.res
	$(link_dll) $(objects) $(objdir)\geturl.exp $(conlibs)

!else
$(geturllib): $(objdir) $(objects)
	$(archive) $(objects) $(networklibs)
!endif

$(objdir)\geturl_test.exe: $(objdir)\geturl_test.obj $(geturllib)
	$(link) $(**) $(conlibs)

$(objdir)\geturl_test.obj: geturl_test.c
	$(compile) -UMAKE_GETURL_DLL $(**)

test:  $(objdir)\geturl_test.exe

install:: all install-exec install-lib

!include <make/install.mak>

depend:

!include <make/clean.mak>

#
# Local Variables:
# mode: makefile
# End:
