################################################################################
#
# Makefile  : Gs Win32
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/04/24 01:14:34 popineau>
#
################################################################################
root_srcdir=..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

!include <make/common.mak>

USE_GNUW32 = 1
USE_GSW32 = 1
MAKE_GSW32 = 1
USE_ADVAPI = 1

!include <make/common.mak>

objects = \
	$(objdir)\gvwgsver.obj \
	$(objdir)\ghostscr.obj 

programs = $(gsw32dll)
libfiles = $(gsw32lib)
includefiles = 

default: all

all: $(objdir) $(gsw32)

lib: $(objdir) $(gsw32lib)

!ifdef GSW32_DLL
DEFS= $(DEFS) -DMAKE_GSW32_DLL

$(gsw32lib): $(objdir) $(objects)
	$(archive) /DEF $(objects)

$(gsw32dll): $(objects) $(objdir)\libgsw32.lib  $(objdir)\libgsw32.res
	$(link_dll) $(**) $(objdir)\libgsw32.exp $(conlibs)
!else
$(gsw32lib): $(objdir) $(objects)
	$(archive) $(objects)
!endif


!include <make/config.mak>
!include <make/install.mak>

install:: install-exec install-lib install-include

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

# 
# Local Variables:
# mode: makefile
# End: