################################################################################
#
# Makefile  : LibTYPE1
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/02/19 02:50:22 popineau>
#
################################################################################
root_srcdir = ..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

USE_GNUW32 = 1
USE_TYPE1 = 1

!include <make/common.mak>

programs = $(type1dll)
libfiles = $(type1lib)
includefiles = 
installdirs = $(bindir) $(includedir) $(libdir)

objects = \
	$(NULL)

default: all

all: $(objdir) $(type1)

lib: $(objdir) $(type1lib)

!ifdef TYPE1_DLL
DEFS = $(DEFS) -DMAKE_TYPE1_DLL

$(type1lib): $(objdir) $(objects) # $(win32defdir)\libtype1.def
	$(archive) /DEF $(objects)

$(type1dll): $(objects) $(objdir)\libtype1.res $(gnuw32lib) $(regexlib) $(zliblib)
	$(link_dll) $(**) $(objdir)\libtype1.exp wsock32.lib $(conlibs)
!else
$(type1lib): $(objdir) $(objects) $(gnuw32lib) $(regexlib) $(zliblib)
	$(archive) $(gnuw32lib) $(regexlib) $(zliblib) wsock32.lib
!ENDIF

!include <make/config.mak>

!include <make/install.mak>

install:: install-exec install-include install-lib

!include <make/clean.mak>

!include <make/rdepend.mak>
!include "./depend.mak"

# 
# Local Variables:
# mode: makefile
# End:
