################################################################################
#
# Makefile  : TeXk / CJKutils / conversion
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <01/11/19 16:28:46 popineau>
#
################################################################################
root_srcdir = ..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

# This is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License, see the file COPYING.

USE_GNUW32 = 1

!include <make/common.mak>

programs = $(objdir)\bg5conv.exe $(objdir)\cefconv.exe $(objdir)\cef5conv.exe \
	$(objdir)\cefsconv.exe $(objdir)\sjisconv.exe

#
# Main target
#
default: all

all: $(objdir) $(programs)

#
# Link target. setargv.obj is provided in the compiler library directory.
#
$(objdir)\bg5conv.exe: $(objdir)\bg5conv.obj $(gnuw32lib)
	$(link) $(**) $(conlibs)

$(objdir)\cefconv.exe: $(objdir)\cefconv.obj $(gnuw32lib)
	$(link) $(**) $(conlibs)

$(objdir)\cef5conv.exe: $(objdir)\cef5conv.obj $(gnuw32lib)
	$(link) $(**) $(conlibs)

$(objdir)\cefsconv.exe: $(objdir)\cefsconv.obj $(gnuw32lib)
	$(link) $(**) $(conlibs)

$(objdir)\sjisconv.exe: $(objdir)\sjisconv.obj $(gnuw32lib)
	$(link) $(**) $(conlibs)

!include <make/config.mak>

!include <make/install.mak>

install:: install-exec

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End:
