################################################################################
#
# Makefile  : TeXk / CJKutils / hbf2gf
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <01/11/19 16:29:20 popineau>
#
################################################################################
root_srcdir = ..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

# This is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License, see the file COPYING.

USE_KPATHSEA = 1
USE_GNUW32 = 1

!include <make/common.mak>

#
# Files
#
programs = $(objdir)\hbf2gf.exe
objects = $(objdir)\hbf.obj $(objdir)\hbf2gf.obj
manfiles = hbf2gf.1

DEFS = $(DEFS) -DHAVE_LIBKPATHSEA -Dmsdos
# for FAT support, set: DEFS = -DNTFAT

#
# Main target
#
default: all

all: $(objdir) $(programs)

#
# Link target. setargv.obj is provided in the compiler library directory.
#
$(objdir)\hbf2gf.exe: $(objects) $(kpathsealib)
	$(link) $(**) $(conlibs)

!include <make/config.mak>

installdirs = $(texmf)\hbf2gf

!include <make/install.mak>

install:: install-exec install-man install-data

install-data::
	-@echo $(verbose) & ( \
		 $(xcopy) cfg\*.* $(texmf)\hbf2gf \
	)

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End:
