################################################################################
#
# Makefile  : Ispell / French GUT dictionary
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/01/18 22:03:56 popineau>
#
################################################################################
root_srcdir = ..\..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

!include <make/common.mak>

sort=$(gnubin)\sort.exe
sortflags=-u -t/ +0f -1 +0 -T .

lang=francais
aff=$(lang).aff
aff8b = $(lang)-TeX8b.aff

dico=$(lang).hash
dico8b=$(lang)-TeX8b.hash

src = \
	dicos\abrev.dico	\
	dicos\helvetismes.dico	\
	dicos\informatique.dico	\
	dicos\math.dico		\
	dicos\noms_propres.dico	\
	dicos\nonverbes-rares.dico	\
	dicos\nonverbes.dico	\
	dicos\series.dico	\
	dicos\typo.dico		\
	dicos\verbes-gp12.dico	\
	dicos\verbes-gp3.dico	\
	dicos\verbes-rares.dico	\
	dicos\verbes-varia.dico

default: all

all: stamp-dico

$(dico): $(lang).dico
	..\..\$(objdir)\buildhash $(lang).dico $(aff) $(dico)

$(dico8b): $(lang).dico
	..\..\$(objdir)\buildhash $(lang).dico $(aff8b) $(dico8b)

$(lang).dico: $(src)
	$(sort) $(sortflags) -o $@ $**

install: install-data

install-data: $(texmf)\ispell\$(dico).gz $(texmf)\ispell\$(dico8b).gz

$(texmf)\ispell\$(dico).gz $(texmf)\ispell\$(dico8b).gz: stamp-dico
	-@$(del) $(texmf)\ispell\$(dico) $(texmf)\ispell\$(dico).gz
	-@$(del) $(texmf)\ispell\$(dico8b) $(texmf)\ispell\$(dico8b).gz
	$(copy) $(dico) $(texmf)\ispell\$(dico)
	$(copy) $(dico8b) $(texmf)\ispell\$(dico8b)
	$(gzip) -9 $(texmf)\ispell\$(dico)
	$(gzip) -9 $(texmf)\ispell\$(dico8b)

stamp-dico: $(dico) $(dico8b)
	date /t > stamp-dico
	time /t >> stamp-dico

clean::
	-@$(del) $(lang).dico $(lang).dico.cnt $(lang).dico.stat $(redir_stderr)

distclean::
	-@$(del) stamp-dico $(dico) $(dico8b) $(redir_stderr)

!include <make/clean.mak>

#
# Local Variables:
# mode: makefile
# End:
