################################################################################
#
# Makefile  : Ispell / German dictionary
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/01/18 22:04:25 popineau>
#
################################################################################
root_srcdir = ..\..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

!include <make/common.mak>

sort=$(gnubin)\sort.exe
sortflags=-u -t/ +0f -1 +0 -T .

lang=deutsch
aff=$(lang).aff

dico=$(lang).hash

src = \
	abkuerz.txt	\
	abkuerz2.txt	\
	adjektive.txt	\
	alphabeta.txt	\
	compeng.txt	\
	elektronik.txt	\
	geogra2.txt	\
	geographie.txt	\
	imperat.txt	\
	infoabk.txt	\
	informatik.txt	\
	klein.txt	\
	latein.txt	\
	marken.txt	\
	namen.txt	\
	orgabk.txt	\
	roemisch.txt	\
	seltenes.txt	\
	technik.txt	\
	verben.txt	\
	vornam2.txt	\
	vornamen.txt	\
	worte.txt	\
	zusammen.txt

all: stamp-dico

$(dico): $(lang).dico
	..\..\$(objdir)\buildhash $(lang).dico $(aff) $(dico)

$(lang).dico: $(src)
	$(sort) $(sortflags) -o $@ $**

install: install-data

install-data: $(texmf)\ispell\$(dico).gz

$(texmf)\ispell\$(dico).gz: stamp-dico
	-@$(del) $(texmf)\ispell\$(dico) $(texmf)\ispell\$(dico).gz
	$(copy) $(dico) $(texmf)\ispell\$(dico)
	$(gzip) -9 $(texmf)\ispell\$(dico)

stamp-dico: $(dico)
	date /t > stamp-dico
	time /t >> stamp-dico

clean::
	-@$(del) $(lang).dico $(lang).dico.cnt $(lang).dico.stat $(redir_stderr)

distclean::
	-@$(del) stamp-dico $(dico) $(redir_stderr)

!include <make/clean.mak>

#
# Local Variables:
# mode: makefile
# End:
