################################################################################
#
# Makefile  : Ispell / Spanish dictionary
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <01/11/18 21:51:49 popineau>
#
################################################################################
root_srcdir = ..\..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

!include <make/common.mak>

sort=$(gnubin)\sort.exe
sortflags=-u -t/ +0f -1 +0 -T .

lang=espanol
aff=$(lang).aff
aff8b = $(lang)-TeX8b.aff

dico=$(lang).hash
dico8b=$(lang)-TeX8b.hash

src = \

all: stamp-dico

$(dico): $(lang).dico
	..\..\$(objdir)\buildhash $(lang).dico $(aff) $(dico)

$(dico8b): $(lang).dico
	..\..\$(objdir)\buildhash $(lang).dico $(aff8b) $(dico8b)

$(lang).dico: $(src)
	$(sort) $(sortflags) -o $@ $**

install: install-data

install-data: $(texmf)\ispell\$(dico).gz $(texmf)\ispell\$(dico8b).gz

$(texmf)\ispell\$(dico).gz $(texmf)\ispell\$(dico8b).gz: stamp-dico
	-@$(del) $(texmf)\ispell\$(dico) $(texmf)\ispell\$(dico).gz
	-@$(del) $(texmf)\ispell\$(dico8b) $(texmf)\ispell\$(dico8b).gz
	$(copy) $(dico) $(texmf)\ispell\$(dico)
	$(copy) $(dico8b) $(texmf)\ispell\$(dico8b)
	$(gzip) -9 $(texmf)\ispell\$(dico)
	$(gzip) -9 $(texmf)\ispell\$(dico8b)

stamp-dico: $(dico) $(dico8b)
	date /t > stamp-dico
	time /t >> stamp-dico

clean::
	$(del) $(lang).dico $(lang).dico.cnt $(lang).dico.stat

distclean::
	$(del) stamp-dico $(dico) $(dico8b)

!include <make/clean.mak>

#
# Local Variables:
# mode: makefile
# End:
