################################################################################
#
# Makefile  : Ltx2rtf / exp-macr
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/01/26 23:06:41 popineau>
#
################################################################################
root_srcdir = ..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

!include <make/common.mak>

DEFS = $(DEFS) -I$(gnuinc)

SUFFIXES = $(SUFFIXES) .f

# Compilation flags.
!IFDEF NODEBUG
optflags = -O2x -G5ds -Gy
!ELSE
optflags = -Od -Zi -G5d
!ENDIF

DEFS = -I$(gnuinclude) $(DEFS)

.f.c:
	f2c $<
	$(perl) getarg.pl < $@ > $@.tmp
	$(move) $@.tmp $@
	$(del) $@.tmp

programs = $(objdir)\exp-macr.exe

default: all

all: $(objdir) $(programs)

$(objdir)\exp-macr.exe: $(objdir)\exp-macr.obj $(gnuw32lib)
	$(link) -entry:MAIN__ -subsystem:console $(objdir)\exp-macr.obj  /LIBPATH:$(gnulib) libf2c.lib $(gnuw32lib) $(conlibs)

exp-macr.c: exp-macr.f exp-macr.inc exp-macr.gen

!include <make/config.mak>
!include <make/install.mak>

install:: install-exec

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End:

