################################################################################
#
# Makefile  : Ltx2rtf / src-gcc
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/05/07 14:10:49 popineau>
#
################################################################################
root_srcdir = ..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

USE_GNUW32 = 1
USE_KPATHSEA = 1

!include <make/common.mak>

DEFS = $(DEFS)	-DHAVE_GETCWD

# Nothing to change below this line
SOURCES=commands.c commands.h cdirect.c direct.h fonts.c fonts.h \
    funct1.c funct1.h funct2.c funct2.h ignore.c ignore.h main.c main.h \
    stack.c stack.h version.h Makefile README Copyright

support=direct.cfg fonts.cfg ignore.cfg config.cfg ..\dvi2pbm.bat ..\dvipsgs.bat

manfiles=ltx2rtf.1

programs = $(objdir)\ltx2rtf.exe \
#	$(objdir)\pbm2pict.exe $(objdir)\pgm2pict.exe

objects = $(objdir)\fonts.obj $(objdir)\cdirect.obj $(objdir)\commands.obj \
	$(objdir)\stack.obj $(objdir)\funct1.obj $(objdir)\funct2.obj   \
	$(objdir)\ignore.obj $(objdir)\main.obj

default: all

all: $(objdir) $(programs)

$(objdir)\ltx2rtf.exe: $(objects) $(kpathsealib)
	$(link) $(**) $(conlibs)

$(objdir)\pbm2pict.exe: $(objdir)\pbm2pict.obj

$(objdir)\pgm2pict.exe: $(objdir)\pgm2pict.obj

!include <make/config.mak>

installdirs = $(texmf)\ltx2rtf

!include <make/install.mak>

install:: install-exec install-data install-man

install-data::
	-@echo $(verbose) & ( \
	 	for %%i in ($(support)) do \
		$(copy) %%i $(texmf)\ltx2rtf\%%~nxi $(redir_stdout) \
	)

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End:


