################################################################################
#
# Makefile  : TeXLive specific
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/05/08 21:51:45 popineau>
#
################################################################################
root_srcdir = ..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32
# End of generated configuration data.
# Makefile for texlive's extra scripts 
# Public domain.

!include <make/common.mak>

{$(texmf)\context\perltk}.pl{$(objdir)}.exe:
	$(perlcomp) $(perlcompflags) $<

{}.pl{$(objdir)}.exe:
	$(perlcomp) $(perlcompflags) $<

{}.{$(objdir)}.exe:
	$(perlcomp) $(perlcompflags) $<

LIVEMFPROGS = \
	mfw.exe

LIVEMPOSTPROGS = \
	metafun.exe

LIVETEXPROGS = \
	amstex.exe \
#	bamstex.exe \
#	blue.exe \
	bplain.exe \
#	cslatex.exe \
#	csplain.exe \
	cyrtexinfo.exe \
	cyramstex.exe \
	cyrlatex.exe \
	cyrtex.exe \
#	hugelatex.exe \
	hugetex.exe \
	jadetex.exe \
#	lamstex.exe \
#	lollipop.exe \
	mex-pl.exe \
	mex.exe \
	mllatex.exe \
	mltex.exe \
	physe.exe \
	phyzzx.exe \
#	platex-pl.exe \
#	platex.exe \
#	startex.exe \
	texinfo.exe \
#	text1.exe \
	texsis.exe \
	xmltex.exe

LIVEETEXPROGS = \
	elatex.exe \
	eplain.exe

LIVEPDFTEXPROGS = \
#	frpdftex.exe \
#	frpdflatex.exe \
#	pdfcslatex.exe \
	pdfjadetex.exe \
	pdfmex.exe \
	pdfmex-pl.exe \
	pdfplatex.exe \
	pdfplatex-pl.exe \
#	pdftexinfo.exe \
	pdfxmltex.exe

LIVEPDFETEXPROGS = \
#	cont-de.exe \
#	cont-en.exe \
#	cont-nl.exe \
#	cont-cz.exe \
#	cont-uk.exe \
	pdfemex.exe \
	pdfemex-pl.exe

LIVEOMEGAPROGS = \
	lambda.exe

LIVESCRIPTS = \
#	inimf inimpost iniomega initex pdfinitex  \
#	virmf virmpost viromega virtex pdfvirtex \
#	einitex pdfeinitex  \
#	evirtex pdfevirtex
#	amstex.bat \
#	blue.bat \
	cont-de.bat \
	cont-en.bat \
	cont-nl.bat \
	cont-uk.bat \
	cont-cz.bat \
	cslatex.bat \
	cslatexd.bat \
	cslatexi.bat \
	cslatexk.bat \
	csplain.bat \
	csplaind.bat \
	csplaini.bat \
	csplaink.bat \
#	elatex.bat \
#	eplain.bat \
#	frtex.bat \
#	frlatex.bat \
	hugelatex.bat \
	hugetex.bat \
#	jadetex.bat \
#	lambda.bat \
#	lamstex.bat \
#	latex.bat \
#	lollipop.bat \
#	mex.bat \
#	mltex.bat \
#	mllatex.bat \
	pdfcslatex.bat \
	pdfcslatexd.bat \
	pdfcslatexi.bat \
	pdfcslatexk.bat \
	pdfcsplain.bat \
	pdfcsplaind.bat \
	pdfcsplaini.bat \
	pdfcsplaink.bat \
#	pdfelatex.bat \
#	pdfjadetex.bat \
#	pdflatex.bat \
#	pdfmex.bat \
	pdftexinfo.bat \
#	physe.bat \
#	phyzzx.bat \
	platex.bat \
	platex-pl.bat \
#	startex.bat \
#	texinfo.bat \
#	texsis.bat \
#	text1.bat 

LIVEPERLSCRIPTS = \
	$(objdir)\mptopdf.exe \
	$(objdir)\nts.exe \
	$(objdir)\pkfix.exe

baseprograms = \
	$(bindir)\tex.exe \
	$(bindir)\etex.exe \
	$(bindir)\pdftex.exe \
	$(bindir)\pdfetex.exe \
	$(bindir)\omega.exe \
	$(bindir)\mf.exe \
	$(bindir)\mpost.exe

all:  $(objdir) $(LIVEPERLSCRIPTS) $(LIVESCRIPTS) $(baseprograms)

default: all

# pkfix.pl: pkfix
# 	$(sed) -e "1,2d" < $** > $@

# nts.pl: $(texmf)\nts\perltk\nts.pl
# 	@$(copy) $(**) $@

$(objdir)\pkfix.exe: pkfix
	$(perlcomp) $(perlcompflags) $(**)

$(objdir)\nts.exe: $(texmf)\nts\perltk\nts.pl
	$(perlcomp) $(perlcompflags) $(**)

!include <make/install.mak>

install:: install-exec

install-exec:: $(LIVEPERLSCRIPTS) $(LIVESCRIPTS) $(baseprograms)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVETEXPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\tex.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVEETEXPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\etex.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVEPDFTEXPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\pdftex.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVEPDFETEXPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\pdfetex.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVEMFPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\mf.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVEMPOSTPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\mpost.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & ( \
		for %%s in ($(LIVEOMEGAPROGS)) do \
			$(del) $(bindir)\%%s \
			& pushd $(bindir) & $(lnexe) .\omega.exe $(bindir)\%%s \
	)
	-@echo $(verbose) & if NOT "$(LIVESCRIPTS)"=="" for %%s in ($(LIVESCRIPTS)) do \
	  $(copy) $(srcdir)\%%s $(scriptdir)\%%s
	-@echo $(verbose) & if NOT "$(LIVEPERLSCRIPTS)"=="" for %%s in ($(LIVEPERLSCRIPTS)) do \
	  $(copy) $(srcdir)\%%s $(scriptdir)\%%~nxs

!include <make/man.mak>
!include <make/clean.mak>

distclean::
	-@$(del) $(LIVEPERLSCRIPTS)

depend:

# Local Variables:
# mode: Makefile
# End:

