################################################################################
#
# Makefile  : TIFF programs/tools
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/02/01 00:26:18 popineau>
#
################################################################################
root_srcdir = ..\..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

NETPBM = 1
USE_GNUW32 = 1
USE_TIFF = 1

!include <make/common.mak>

#

DEFS = $(DEFS) -I$(TIFFLIBDIR) -DBINMODE=\"b\" -D_WINDOWS

#
objects = \
	$(objdir)\fax2tiff.obj \
	$(objdir)\fax2ps.obj \
	$(objdir)\gif2tiff.obj \
	$(objdir)\pal2rgb.obj \
	$(objdir)\ppm2tiff.obj \
	$(objdir)\rgb2ycbcr.obj \
	$(objdir)\ras2tiff.obj \
	$(objdir)\thumbnail.obj \
	$(objdir)\tiff2bw.obj \
	$(objdir)\tiff2rgba.obj \
	$(objdir)\tiff2ps.obj \
	$(objdir)\tiffcmp.obj \
	$(objdir)\tiffcp.obj \
	$(objdir)\tiffdither.obj \
	$(objdir)\tiffdump.obj \
	$(objdir)\tiffinfo.obj \
	$(objdir)\tiffmedian.obj \
	$(objdir)\tiffset.obj \
	$(objdir)\tiffsplit.obj \
	$(NULL)
programs = \
	$(objdir)\fax2tiff.exe \
	$(objdir)\fax2ps.exe \
	$(objdir)\gif2tiff.exe \
	$(objdir)\pal2rgb.exe \
	$(objdir)\ppm2tiff.exe \
	$(objdir)\rgb2ycbcr.exe \
	$(objdir)\thumbnail.exe \
	$(objdir)\ras2tiff.exe \
	$(objdir)\tiff2bw.exe \
	$(objdir)\tiff2rgba.exe \
	$(objdir)\tiff2ps.exe \
	$(objdir)\tiffcmp.exe \
	$(objdir)\tiffcp.exe \
	$(objdir)\tiffdither.exe \
	$(objdir)\tiffdump.exe \
	$(objdir)\tiffinfo.exe \
	$(objdir)\tiffmedian.exe \
	$(objdir)\tiffset.exe \
	$(objdir)\tiffsplit.exe \
	$(NULL)

{$(objdir)}.obj{$(objdir)}.exe:
	$(link) $< $(tifflib) $(gnuw32lib) $(conlibs)

all:	$(objdir) $(programs)

$(programs) : $(objects) $(tifflib) $(gnuw32lib) 

!include <make/install.mak>

install:: install-exec install-man

install-man::
	-@echo $(verbose) & ( \
		for %i in ($(programs)) do \
			$(copy) ..\man\%~ni.1 $(mandir)\man1\%~ni.1 $(redir_stdout) \
	)

!include <make/clean.mak>

!include <make/rdepend.mak>
!include "./depend.mak"

# 
# Local Variables:
# mode: Makefile
# End: