#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <sys/types.h>
#include <sys/stat.h>

#define stat _stat

void main(int argc, char *argv[])
{
  char **newargv, *p, *script;
  char perlpath[260];
  int i;
  struct stat stat_buf;

  if ((newargv = (char **)malloc((argc + 2)*sizeof(char *))) == NULL) {
    perror("Not enough memory!\n");
    exit(1);
  }

  for (i = 0; i < argc; i++) {
    newargv[i+1] = argv[i];
  }
  newargv[1] = _pgmptr;
  /* Strip suffix from argv[0] */
  if (p = strrchr(newargv[1], '.'))
    *p = '\0';

  /* Look for script name 'foo' or 'foo.pl' */
  if ((script = malloc(strlen(newargv[1])+4)) == NULL) {
    perror("Not enough memory!\n");
    exit(1);
  }
  strcpy(script, newargv[1]);
  if (stat(script, &stat_buf) == -1) {
    strcat(script, ".pl");
    if (stat(script, &stat_buf) == -1) {
      fprintf(stderr, "%s: the stub as been copied, but no accompanying perl script\nwith a name %s\nor\n%s.pl\ncan be found in the same directory.\nAborting.\n",
	      newargv[1], newargv[1], newargv[1]);
      exit(1);
    }
  }
  newargv[1] = script;
  /* Keep the original name */
  newargv[0] = newargv[1];
  /* Last one is NULL */
  newargv[argc+1] = NULL;

  *perlpath = '\0';
  _searchenv("perl.exe", "PATH", perlpath);
  if (*perlpath == '\0') {
    fprintf(stderr, "Perl not found !\n");
    exit(1);
  }
  /* Run the command */
  if (_spawnv(_P_WAIT, perlpath, newargv) == -1) {
    perror("Can't execv perl !\n");
    exit(1);
  }
  exit(0);
}
