################################################################################
#
# Makefile  : Cmdutils
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/01/21 11:57:31 popineau>
#
################################################################################
root_srcdir = ..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

USE_GNUW32 = 1

!include <make/common.mak>

pdfdde = $(objdir)\pdfdde.exe

programs = \
	$(objdir)\lnexe.exe \
	$(objdir)\runperl.exe  \
	$(pdfdde)

pdfddechilds = $(objdir)\pdfopen.exe $(objdir)\pdfclose.exe

default: all

all: $(objdir) $(programs) $(pdfdde)

# Win32 Only.
# In order to save some disk space, this lnexe.exe can resolve to different
# exe files. Unfortunately, it needs to be compiled twice in its current 
# state.
$(objdir)\lnexe-tmp.obj: $(srcdir)\lnexe.c 
	@echo define RDATA 0xE00 | sed "s/define/#define/" > $(srcdir)\lnexe.h
	$(compile) $(srcdir)\lnexe.c

$(objdir)\lnexe-tmp.exe: $(objdir)\lnexe-tmp.obj
	$(link) $(objdir)\lnexe-tmp.obj $(conlibs)

$(objdir)\lnexe.obj: $(srcdir)\lnexe.c $(objdir)\lnexe-tmp.exe
	@dumpbin /headers $(objdir)\lnexe-tmp.exe \
	| grep data | sed -n -e "/^[ \t]*\.rdata/,/^[ \t]*\.data/p" \
	| sed -n -e "/file pointer/p" \
	| sed -e "s/^[ \t]*\([0-9A-Z]*\).*$$/#define RDATA 0x\1/" \
	| sed -e "s/00$$/80/" > $(srcdir)\lnexe.h
	$(compile) $(srcdir)\lnexe.c
#	-$(RM) $(objdir)\lnexe-tmp.*

$(objdir)\lnexe.exe: $(objdir)\lnexe.obj $(objdir)\lnexe.res 
	$(link) $(**) $(conlibs)

$(objdir)\runperl.exe: $(objdir)\runperl.obj $(objdir)\runperl.res 
	$(link) $(**) $(conlibs)


$(objdir)\pdfdde.exe: $(objdir)\pdfdde.obj $(gnuw32lib)
	$(link) $(**) $(conlibs) shell32.lib

!include <make/config.mak>

installdirs = $(bindir)

!include <make/install.mak>

install:: install-exec

install-exec::
	-@echo $(verbose) & ( \
	for %%i in ($(pdfddechilds)) \
		do $(copy) $(pdfdde) $(bindir)\%%~nxi \
	) $(redir_stdout)

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

#Local Variables:
#mode: Makefile
#End: