INCLUDE=$(INCLUDE);../..

# Makefile for expat library
# The library already compiles under win32.
# This Makefile for accomodating the needs of fpTeX.
# (maybe building a .dll later)

!include <make/paths.mak>
!include <make/common.mak>
!include <make/library.mak>
!include <make/programs.mak>

c_auto_h_dir = $(kpathsea_srcdir)

OBJS = \
	$(objdir)\xmlrole.obj     \
	$(objdir)\xmltok.obj      \
	$(objdir)\xmlparse.obj

default: all

DEFS =  -DCOMPILED_FROM_DSP -DVERSION=\"expat_1.95.1\" $(DEFS)

!ifdef EXPAT_DLL
DEFS = -DMAKE_EXPAT_DLL $(DEFS)

EXPATLIB = $(objdir)\expat.lib $(objdir)\expat.dll

all: $(objdir) $(EXPATLIB)

$(objdir)\expat.lib: $(objdir) $(OBJS)
	$(archive_command) /DEF $(OBJS)

$(objdir)\expat.dll: $(objdir) $(objdir)\expat.lib $(OBJS) $(objdir)\expat.res
	$(dll_command) $(objdir)\expat.exp $(OBJS) $(objdir)\expat.res $(libc) $(XLIBS)

!else
EXPATLIB = $(objdir)\expat.lib

all: $(objdir) $(EXPATLIB)

$(objdir)\expat.lib: $(objdir) $(OBJS)
	$(archive_command) $(OBJS)

!endif

install: $(mktexdir) all
	$(mktexdir) $(toolsprefix)\bin $(toolsprefix)\lib $(toolsprefix)\include \
	$(bindir) $(libdir) $(includedir)
	$(CP) expat.h $(toolsprefix)\include
	$(CP) $(objdir)\expat.lib $(toolsprefix)\lib
	$(CP) expat.h $(includedir)
	$(CP) $(objdir)\expat.lib $(libdir)
!IFDEF EXPAT_DLL
	$(CP) $(objdir)\expat.dll $(toolsprefix)\bin
	$(CP) $(objdir)\expat.dll $(bindir)
!ENDIF

uninstall:

!include <make/man.mak>
!include <make/clean.mak>
!include <make/tkpathsea.mak>
!include <make/version.mak>

distclean clean::
	-@$(RM) Release\* Debug\* *.aps *.ncb *.opt

#depend:
#	makedepend -- $(CFLAGS) -- *.[ch]
!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End:

