# makefile for gnuw32 library
INCLUDE=$(INCLUDE);../../win32

!include <make/paths.mak>
!include <make/common.mak>
!include <make/library.mak>
!include <make/programs.mak>

{$(kpathsea_srcdir)}.c{$(objdir)}.obj:
	$(compile) $<

XCPPFLAGS=-I../include -UKPSE_DLL # -DTRACE=1
XLDFLAGS=

!if defined(GNUW32_DLL)
DEFS= $(DEFS) -DMAKE_GNUW32_DLL
!endif

c_auto_h_dir = $(kpathsea_srcdir)

OBJS = \
	$(objdir)\error.obj	\
	$(objdir)\getopt.obj	\
	$(objdir)\getopt1.obj	\
	$(objdir)\popen.obj    	\
	$(objdir)\stat.obj     	\
	$(objdir)\system.obj   	\
	$(objdir)\string.obj   	\
	$(objdir)\filename.obj 	\
	$(objdir)\dirent.obj   	\
	$(objdir)\time.obj     	\
	$(objdir)\user.obj     	\
	$(objdir)\home.obj     	\
	$(objdir)\volume.obj   	\
	$(objdir)\lookcmd.obj  	\
	$(objdir)\ghostscr.obj 

!IFDEF GNUW32_DLL
LIBGNUW32 = $(objdir)\libgnuw32.dll $(objdir)\libgnuw32.lib

all: $(objdir) $(objdir)\libgnuw32.lib $(objdir)\libgnuw32.dll $(objdir)\setargv.obj

$(objdir)\libgnuw32.lib: $(objdir) $(OBJS)
	$(archive_command) /DEF $(OBJS)

$(objdir)\libgnuw32.dll: $(OBJS) $(zlib) $(objdir)\libgnuw32.lib  $(objdir)\libgnuw32.res
	$(dll_command) $(**) $(objdir)\libgnuw32.exp $(XLDFLAGS) $(LIBS)
!ELSE
LIBGNUW32 = $(objdir)\libgnuw32.lib

all: $(objdir) $(objdir)\libgnuw32.lib $(objdir)\setargv.obj

$(objdir)\libgnuw32.lib: $(objdir) $(OBJS)
	$(archive_command) $(OBJS)
!ENDIF

# $(objdir)\getopt.obj: $(kpathsea_srcdir)\getopt.c
#	$(compile) -UKPSE_DLL -UGNUW32_DLL $(kpathsea_srcdir)\getopt.c

$(objdir)\setargv.obj: ./setargv.c
	$(compile) -D__NT__ -D__MSC__ -DFIXARG0 -DGLOB -DUPPERCASE -DLCFAT $**

!include <make/libsrul.mak>

install: $(LIBGNUW32)
	$(mktexdir) $(toolsprefix)\bin \
		$(toolsprefix)\lib $(toolsprefix)\include $(bindir)
	$(CP) ..\include\win32lib.h $(toolsprefix)\include
	$(CP) ..\include\oldnames.h $(toolsprefix)\include
	$(CP) $(objdir)\libgnuw32.lib $(toolsprefix)\lib
!IFDEF GNUW32_DLL
	$(CP) $(objdir)\libgnuw32.dll $(toolsprefix)\bin
	$(CP) $(objdir)\libgnuw32.dll $(bindir)
!ENDIF

!include <make/man.mak>
!include <make/clean.mak>
!include <make/tkpathsea.mak>
!include <make/version.mak>

clean::
	-@$(RM) $(objdir)\libgnuw32.lib $(objdir)\libgnuw32.dll \
		$(objdir)\gnuw32test.exe

!include <make/rdepend.mak>
!include "./depend.mak"

# 
# Local Variables:
# mode: makefile
# End: