################################################################################
#
# Makefile  : Omega, web2c win32.mak makefile fragment to build Omega
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <01/12/14 19:05:59 popineau>
#
################################################################################

Makefile: $(win32make_srcdir)/omega.mak

omegaware_programs = $(objdir)\otangle.exe $(objdir)\odvicopy.exe $(objdir)\odvitype.exe

omega_programs = $(omega) $(otangle) $(odvicopy) $(odvitype) \
                 $(otps_programs) $(omegafonts_programs)

# The C sources.
omega_c = omega.c
omegaware_c = odvicopy.c odvitype.c otangle.c
omega_o = $(objdir)\omega.obj $(objdir)\omegafirst.obj $(objdir)\omegabis.obj

# Generation of the web and ch files.
odvicopy.web: omegaware\odvicopy.web
	-@$(del) $@
	$(copy) $(srcdir)\omegaware\odvicopy.web $@
odvicopy.ch: omegaware\odvicopy.ch
	-@$(del) $@
	$(copy) $(srcdir)\omegaware\odvicopy.ch $@
odvitype.web: omegaware\odvitype.web
	-@$(del) $@
	$(copy) $(srcdir)\omegaware\odvitype.web $@
odvitype.ch: omegaware\odvitype.ch
	-@$(del) $@
	$(copy) $(srcdir)\omegaware\odvitype.ch $@
omega.web: $(objdir)\tie.exe tex.web 
omega.web: omegadir/omnode.ch
omega.web: omegadir/om16bit.ch
omega.web: omegadir/omstr.ch
omega.web: omegadir/omfont.ch
omega.web: omegadir/omchar.ch
omega.web: omegadir/omfi.ch
omega.web: omegadir/ompar.ch
omega.web: omegadir/omocp.ch
omega.web: omegadir/omfilter.ch
omega.web: omegadir/omtrans.ch
omega.web: omegadir/omdir.ch
omega.web: omegadir/omxml.ch
	.\$(objdir)\tie -m omega.web tex.web \
	 omegadir/omnode.ch \
	 omegadir/om16bit.ch \
	 omegadir/omstr.ch \
	 omegadir/omfont.ch \
	 omegadir/omchar.ch \
	 omegadir/omfi.ch \
	 omegadir/ompar.ch \
	 omegadir/omocp.ch \
	 omegadir/omfilter.ch \
	 omegadir/omtrans.ch \
	 omegadir/omdir.ch \
	 omegadir/omxml.ch
omega.ch: $(objdir)\tie.exe omega.web
omega.ch: omegadir/comnode.ch
omega.ch: omegadir/com16bit.ch
omega.ch: omegadir/comstr.ch
omega.ch: omegadir/comfont.ch
omega.ch: omegadir/comchar.ch
omega.ch: omegadir/comfi.ch
omega.ch: omegadir/compar.ch
omega.ch: omegadir/comocp.ch
omega.ch: omegadir/comfilter.ch
omega.ch: omegadir/comtrans.ch
omega.ch: omegadir/comdir.ch
omega.ch: omegadir/comxml.ch
omega.ch: omegadir/comsrcspec.ch
	.\$(objdir)\tie -c omega.ch omega.web \
	omegadir/comnode.ch \
	omegadir/com16bit.ch \
	omegadir/comstr.ch \
	omegadir/comfont.ch \
	omegadir/comchar.ch \
	omegadir/comfi.ch \
	omegadir/compar.ch \
	omegadir/comocp.ch \
	omegadir/comfilter.ch \
	omegadir/comtrans.ch \
	omegadir/comdir.ch \
	omegadir/comxml.ch \
	omegadir/comsrcspec.ch
otangle.web: omegaware\otangle.web
	-@$(del) $@
	$(copy) $(srcdir)\omegaware\otangle.web $@
otangle.ch: omegaware\otangle.ch
	-@$(del) $@
	$(copy) $(srcdir)\omegaware\otangle.ch $@

!if 0
# Bootstrapping otangle requires making it with itself.
$(objdir)\otangle.exe: $(objdir)\otangle.obj
	$(link) $(objdir)\otangle.obj $(kpathsealib) $(proglib) $(conlibs)
	$(make) $(common_makeargs) otangleboot.p
# otangle.p is a special case, since it is needed to compile itself.  We
# convert and compile the (distributed) otangleboot.p to make a otangle
# which we use to make the other programs.
otangle.p: $(objdir)\otangleboot.exe otangle.web otangle.ch
	.\$(objdir)\otangleboot.exe otangle.web otangle.ch

$(objdir)\otangleboot.exe: $(objdir) $(objdir)\otangleboot.obj
	$(link) $(objdir)\otangleboot.obj $(kpathsealib) $(proglib) $(conlibs)
otangleboot.c: stamp-otangle $(web2c_programs) $(web2c_aux)
	$(web2c) otangleboot
otangleboot.h: stamp-otangle $(web2c_programs) $(web2c_aux)
	$(web2c) otangleboot
# omegaware/otangleboot.p is in the distribution.
stamp-otangle: omegaware\otangleboot.p
	-@$(del) otangleboot.p
	$(copy) $(srcdir)\omegaware\otangleboot.p otangleboot.p
	date /t >stamp-otangle & time /t >> stamp-otangle
# This is not run unless otangle.web or otangle.ch is changed.
otangleboot.p: omegaware\otangle.web omegaware\otangle.ch
	.\$(objdir)\otangle otangle.web otangle.ch
	$(move) otangle.p omegaware\otangleboot.p
	-@$(del) otangleboot.p
	$(copy) omegaware\otangleboot.p otangleboot.p
	date /t >stamp-otangle & time /t >> stamp-otangle
	$(make) $(common_makeargs) $(objdir)\otangle.exe
!endif

# Three additional files
omegafirst.c: omegadir\omega.c 
	-@$(del) $@
	$(copy) $(srcdir)\omegadir\omega.c $@
	$(touch) $@
omegabis.c: omegadir\omegabis.c 
	-@$(del) $@
	$(copy) $(srcdir)\omegadir\omegabis.c $@
omegamem.h: omegadir\omegamem.h
	-@$(del) $@
	$(copy) $(srcdir)\omegadir\omegamem.h $@
#       !!! FIXME !!! `touch' is insecure, it can swallow chars at
#       the beginning of the file !
#	$(touch) $@

# Some additional programs for Omega: the programs themselves are named
# in the variable otps_programs, defined above.
otps\$(objdir)\otp2ocp.exe otps\$(objdir)\outocp.exe:
	-@echo $(verbose) & ( \
		pushd otps & $(make) all & popd \
	)
omegafonts\$(objdir)\omfonts.exe:
	-@echo $(verbose) & ( \
		pushd omegafonts & $(make) all & popd \
	)

# end of omega.mk
#  
# Local variables:
# page-delimiter: "^# \f"
# mode: Makefile
# End:
