################################################################################
#
# Makefile  : rdepend, rules to build depend.mak dependencies
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/06/02 23:55:22 popineau>
#
################################################################################
#
# Have to use -M, not -MM, since we use <kpathsea/...> instead of
# "kpathsea/..." in the sources.  But that means we have to remove the
# directory prefixes and all the system include files.
# And <kpathsea/paths.h> is generated, not part of the distribution.
# 
# And, there's no need for any installer/user to ever run this, it can
# only cause trouble. So comment it out in the distribution.
# (It doesn't work when the source and build directories are different.)
!if exist(c-auto.in)
c_auto_h_dir = .
!else
c_auto_h_dir = $(kpathseadir)
!endif

SYS_INCLUDE = -I"$(MSVCROOT:\=/)/include" -I"$(MSVCROOT:\=/)/PlatformSDK/include"
depend:: $(c_auto_h_dir)/c-auto.h $(win32makedir)/rdepend.mak
	$(makedepend) -f- -p"$$(objdir)\\" $(makedepend_cflags) -I$(c_auto_h_dir) $(SYS_INCLUDE) *.c *.cc \
	| $(sed) -e "s,\\,/,g" \
		-e "s,/[ ]*$$,\\," \
	        -e "s,$(MSVCROOT:\=/)/include/[^ ]*,,g" \
	        -e "s,$(MSVCROOT:\=/)/PlatformSDK/include/[^ ]*,,g" \
!ifdef kpathseadir
		-e "s,$(kpathseadir:\=/)/\.\./kpathsea/,$$(kpathseadir)/,g" \
!if "$(kpathseadir)" != "."
		-e "s,$(kpathseadir:\=/)/,$$(kpathseadir)/,g" \
!endif
!endif
!ifdef gnuw32dir
		-e "s,$(gnuw32dir:\=/)/,$$(gnuw32dir)/,g" \
!endif
!ifdef gsw32dir
		-e "s,$(gsw32dir:\=/)/,$$(gsw32dir)/,g" \
!endif
!ifdef zlibdir
		-e "s,$(zlibdir:\=/)/,$$(zlibdir)/,g" \
!endif
!ifdef pngdir
		-e "s,$(pngdir:\=/)/,$$(pngdir)/,g" \
!endif
!ifdef regexdir
		-e "s,$(regexdir:\=/)/,$$(regexdir)/,g" \
!endif
!ifdef bzip2dir
		-e "s,$(bzip2dir:\=/)/,$$(bzip2dir)/,g" \
!endif
!ifdef tiffdir
		-e "s,$(tiffdir:\=/)/,$$(tiffdir)/,g" \
!endif
!ifdef jpegdir
		-e "s,$(jpegdir:\=/)/,$$(jpegdir)/,g" \
!endif
!ifdef mktexdir
		-e "s,$(mktexdir:\=/)/,$$(mktexdir)/,g" \
!endif
!ifdef xpdfdir
		-e "s,$(xpdfdir:\=/)/,$$(xpdfdir)/,g" \
!endif
!ifdef geturldir
		-e "s,$(geturldir:\=/)/,$$(geturldir)/,g" \
!endif
# FIXME : if needed !
#	        -e "s, /[^ ]*,,g" \
#	        -e "s, [A-z]:/[^ ]*,,g" \
	        -e "s,$$(objdir)\\dvi2xx.obj,$$(objdir)\\dvilj.obj $$(objdir)\\dvilj2p.obj $$(objdir)\\dvilj4.obj $$(objdir)\\dvilj4l.obj," \
	        -e "s,lex.yy,$$(LEX_OUTPUT_ROOT),g" \
	  | $(grep) -ve "^[ 	]*\\$$" \
	  | $(awk) -f $(top_srcdir)/unbackslsh.awk \
	  >depend.mak
# If kpathsea, we're making .lo library objects instead of .o's.
#	pwd | grep -v kpathsea >/dev/null \
#	  || (sed -e 's/\.o:/.lo:/' -e 's/kpsewhich.lo:/kpsewhich.o:/' \
#	      <depend.mk >depend-tmp.mk; mv depend-tmp.mk depend.mk)

# Let's stick a rule for TAGS here, just in case someone wants them.
# (We don't put them in the distributions, to keep them smaller.)
#TAGS: *.c *.h
#	pwd | grep kpathsea >/dev/null && append=../kpathsea/TAGS; \
#	  etags $$append *.[ch]

depend.mak: depend

# Prevent GNU make 3.[59,63) from overflowing arg limit on system V.
.NOEXPORT:

# End of rdepend.mak.
#
# Local Variables:
# mode: Makefile
# End:
