package cauto;

use Exporter ();
use file_utils qw(look_for);

@ISA = qw(Exporter);
@EXPORT_OK = qw(configure_cauto $kpsever $web2cver); 

%excludes = (
	     'libintl.h' => 1
	     );
# List of features useful from autoconf that Win32 has.
%have_features = (
		  'A4' => 1,
		  'A4_PAPER' => 1,
		  'APPDEFDIR' => 'no',
		  'ASM_NEEDS_UNDERSCORE' => 'no',
		  'BMBYTES' => 4,
		  'BMTYPE' => 'int',
		  'BROKEN_STRTOD' => 'no',
		  'BUTTONS' => 'no',
		  'CLOSEDIR_VOID' => 'no',
		  'CRAY_STACKSEG_END' => 'no',
		  'C_ALLOCA' => 'no',
		  'C_GETLOADAVG' => 'no',
		  'DEBUG' => 'no',
		  'DEFAULT_CHARSET' => '"iso8859-1"',
		  'DGUX' => 'no',
		  'EDITOR' => '"notepad %s"',
		  'ENABLE_NLS' => 'no',
		  'EPSFWIN' => 'no',
		  'FREETYPE2' => 'no',
		  'FUNNY_CORE_DUMP' => 'no',
		  'GETCWD_FORKS' => 'no',
		  'GETGROUPS_T' => 'no',
		  'GETLOADAVG_PRIVILEGED' => 'no',
		  'GNU_PACKAGE' => 'no',
		  'GREY' => 1,
		  'GWINSZ_IN_SYS_IOCTL' => 'no',
		  'GWINSZ_IN_SYS_PTY' => 'no',
		  'HAVE_ACCESS' => 'no',
		  'HAVE_ALLOCA' => 1,
		  'HAVE_ALLOCA_H' => 'no',
		  'HAVE_ARGZ_H' => 'no',
		  'HAVE_ARPA_INET_H' => 'no',
		  'HAVE_ASSERT_H' => 1,
		  'HAVE_BASENAME' => 'no',
		  'HAVE_BCMP' => 'no',
		  'HAVE_BCOPY' => 'no',
		  'HAVE_BSTRING_H' => 'no',
		  'HAVE_BTOWC' => 1,
		  'HAVE_BZERO' => 'no',
		  'HAVE_CATGETS' => 'no',
		  'HAVE_CC_CONCAT' => 'no',
		  'HAVE_CHROOT' => 'no',
		  'HAVE_CLOSEDIR' => 'no',
		  'HAVE_CRYPT' => 'no',
		  'HAVE_CTIME' => 'yes',
		  'HAVE_CTYPE_H' => 'no',
		  'HAVE_C_LINE' => 'no',
		  'HAVE_DCGETTEXT' => 'no',
		  'HAVE_DECL_STRCASECMP' => 1,
		  'HAVE_DECL_STRCOLL' => 1,
		  'HAVE_DECL_STRERROR' => 1,
		  'HAVE_DECL_STRNCASECMP' => 1,
		  'HAVE_DIRENT_H' => 'no',
		  'HAVE_DOPRNT' => 'no',
		  'HAVE_DUP2' => 1,
		  'HAVE_ENDGRENT' => 'no',
		  'HAVE_ENDPWENT' => 'no',
		  'HAVE_ERRNO_H' => 'no',
		  'HAVE_FCNTL_H' => 'no',
		  'HAVE_FEOF_UNLOCKED' => 'no',
		  'HAVE_FGETS_UNLOCKED' => 'no',
		  'HAVE_FILENO' => 'no',
		  'HAVE_FLOAT_H' => 1,
		  'HAVE_FLOCK' => 'no',
		  'HAVE_FLOOR' => 1,
		  'HAVE_FREETYPE_FREETYPE_H' => 'no',
		  'HAVE_FREETYPE_H' => 'no',
		  'HAVE_FSEEK64' => 'no',
		  'HAVE_FSYNC' => 'no',
		  'HAVE_FTIME' => 1,
		  'HAVE_FTRUNCATE' => 'no',
		  'HAVE_GETCWD' => 'no',
		  'HAVE_GETDELIM' => 'no',
		  'HAVE_GETEGID' => 'no',
		  'HAVE_GETEUID' => 'no',
		  'HAVE_GETGID' => 'no',
		  'HAVE_GETGROUPS' => 'no',
		  'HAVE_GETHOSTBYADDR' => 1,
		  'HAVE_GETHOSTBYNAME' => 1,
		  'HAVE_GETHOSTNAME' => 1,
		  'HAVE_GETLOADAVG' => 'no',
		  'HAVE_GETLOADAVG' => 'no',
		  'HAVE_GETOPT' => 'no',
		  'HAVE_GETPAGESIZE' => 'no',
		  'HAVE_GETTEXT' => 'no',
		  'HAVE_GETTIMEOFDAY' => 'no',
		  'HAVE_GETUID' => 'no',
		  'HAVE_GETUSERSHELL' => 'no',
		  'HAVE_GETWD' => 1,
		  'HAVE_ICONV' => 'no',
		  'HAVE_IEEEFP_H' => 'no',
		  'HAVE_INDEX' => 1,
		  'HAVE_INET_NTOA' => 1,
		  'HAVE_INITGROUPS' => 'no',
		  'HAVE_INTTYPES_H' => 'no',
		  'HAVE_IO_H' => 1,
		  'HAVE_ISASCII' => 1,
		  'HAVE_ISATTY' => 1,
		  'HAVE_ISINF' => 'no',
		  'HAVE_ITOA' => 1,
		  'HAVE_KPATHSEA' => 1,
		  'HAVE_KPSE_FORMATS' => 1,
		  'HAVE_LANGINFO_CODESET' => 'no',
		  'HAVE_LC_MESSAGES' => 'no',
		  'HAVE_LIBBSD' => 'no',
		  'HAVE_LIBCRYPT' => 'no',
		  'HAVE_LIBDBM' => 'no',
		  'HAVE_LIBDGC' => 'no',
		  'HAVE_LIBI' => 'no',
		  'HAVE_LIBINTL_H' => 'no',
		  'HAVE_LIBKSTAT' => 'no',
		  'HAVE_LIBM' => 'no',
		  'HAVE_LIBN' => 'no',
		  'HAVE_LIBNDBM' => 'no',
		  'HAVE_LIBOS' => 'no',
		  'HAVE_LIBPNG' => 1,
		  'HAVE_LIBPOSIX' => 'no',
		  'HAVE_LIBSEC' => 'no',
		  'HAVE_LIBSHADOW' => 'no',
		  'HAVE_LIBSUN' => 'no',
		  'HAVE_LIBTERMCAP' => 'no',
		  'HAVE_LIBTERMLIB' => 'no',
		  'HAVE_LIBWWW' => 'no',
		  'HAVE_LIBWWW_H' => 'no',
		  'HAVE_LIBYPSEC' => 'no',
		  'HAVE_LIBZ' => 1,
		  'HAVE_LIMITS_H' => 1,
		  'HAVE_LOCALE_H' => 1,
		  'HAVE_LONG_LONG' => 1,
		  'HAVE_MACH_MACH_H' => 'no',
		  'HAVE_MALLOC_H' => 1,
		  'HAVE_MEMCHR' => 1,
		  'HAVE_MEMCMP' => 1,
		  'HAVE_MEMCPY' => 1,
		  'HAVE_MEMMOVE' => 1,
		  'HAVE_MEMORY_H' => 1,
		  'HAVE_MEMPCPY' => 1,
		  'HAVE_MEMSET' => 1,
		  'HAVE_MKSTEMP' => 'no',
		  'HAVE_MKSTEMPS' => 'no',
		  'HAVE_MKTIME' => 1,
		  'HAVE_MMAP' => 'no',
		  'HAVE_MODF' => 1,
		  'HAVE_MUNMAP' => 'no',
		  'HAVE_NCURSES_TERMCAP_H' => 'no',
		  'HAVE_NDIR_H' => 'no',
		  'HAVE_NETDB_H' => 'no',
		  'HAVE_NETINET_IN_H' => 'no',
		  'HAVE_NEW_H' => 'yes',
		  'HAVE_NLS' => 'no',
		  'HAVE_NL_TYPES_H' => 'no',
		  'HAVE_OMEGA_FORMATS' => 1,
		  'HAVE_OPENDIR' => 'no',
		  'HAVE_PAPER_H' => 'no',
		  'HAVE_PATHS_H' => 'no',
		  'HAVE_PIPE' => 1,
		  'HAVE_POLL' => 'no',
		  'HAVE_POLL_H' => 'no',
		  'HAVE_POPEN' => 1,
		  'HAVE_POW' => 1,
		  'HAVE_PROC_UPTIME' => 'no',
		  'HAVE_PROGRAM_INVOCATION_NAME' => 'no',
		  'HAVE_PROTOTYPES' => 1,
		  'HAVE_PSTAT_GETDYNAMIC' => 'no',
		  'HAVE_PUTENV' => 1,
		  'HAVE_PWD_H' => 'no',
		  'HAVE_PWD_H' => 'no',
		  'HAVE_READDIR' => 'no',
		  'HAVE_RENAME' => 1,
		  'HAVE_RINDEX' => 1,
		  'HAVE_RINT' => 1,
		  'HAVE_SELECT' => 'no',
		  'HAVE_SELECT_H' => 'no',
		  'HAVE_SETENV' => 1,
		  'HAVE_SETHOSTNAME' => 'no',
		  'HAVE_SETLOCALE' => 1,
		  'HAVE_SETMODE' => 1,
		  'HAVE_SETVBUF' => 'no',
		  'HAVE_SHADOW_H' => 'no',
		  'HAVE_SIGACTION' => 'no',
		  'HAVE_SIGNAL' => 1,
		  'HAVE_SIGNAL_H' => 'no',
		  'HAVE_SIGPROCMASK' => 'no',
		  'HAVE_SIGSETMASK' => 'no',
		  'HAVE_SNPRINTF' => 1,
		  'HAVE_SOCKS' => 'no',
		  'HAVE_SQRT' => 1,
		  'HAVE_SSL' => 'no',
		  'HAVE_STAT' => 1,
		  'HAVE_STAT_H' => 'no',
		  'HAVE_STDARG_H' => 1,
		  'HAVE_STDDEF_H' => 'no',
		  'HAVE_STDINT_H' => 'no',
		  'HAVE_STDIO_H' => 1,
		  'HAVE_STDLIB_H' => 1,
		  'HAVE_STIME' => 'no',
		  'HAVE_STPCPY' => 1,
		  'HAVE_STRCASECMP' => 1,
		  'HAVE_STRCHR' => 1,
		  'HAVE_STRCOLL' => 1,
		  'HAVE_STRCSPN' => 1,
		  'HAVE_STRDUP' => 1,
		  'HAVE_STREAMS' => 'no',
		  'HAVE_STRERROR' => 1,
		  'HAVE_STRFTIME' => 1,
		  'HAVE_STRINGS_H' => 'no',
		  'HAVE_STRING_H' => 1,
		  'HAVE_STRLWR' => 1,
		  'HAVE_STRNCASECMP' => 1,
		  'HAVE_STRPTIME' => 'no',
		  'HAVE_STRRCHR' => 1,
		  'HAVE_STRSPN' => 1,
		  'HAVE_STRSTR' => 1,
		  'HAVE_STRTOL' => 1,
		  'HAVE_STRTOUL' => 1,
		  'HAVE_STRUCT_UTIMBUF' => 1,
		  'HAVE_ST_BLKSIZE' => 'no',
		  'HAVE_SYMLINK' => 'no',
		  'HAVE_SYSINFO' => 'no',
		  'HAVE_SYSLOG' => 'no',
		  'HAVE_SYSLOG' => 'no',
		  'HAVE_SYSLOG_H' => 'no',
		  'HAVE_SYSTEM' => 1,
		  'HAVE_SYS_BSDTYPES_H' => 'no',
		  'HAVE_SYS_DIR_H' => 'no',
		  'HAVE_SYS_FCNTL_H' => 'no',
		  'HAVE_SYS_FILE_H' => 'no',
		  'HAVE_SYS_NDIR_H' => 'no',
		  'HAVE_SYS_PARAM_H' => 'no',
		  'HAVE_SYS_PTEM_H' => 'no',
		  'HAVE_SYS_SELECT_H' => 'no',
		  'HAVE_SYS_SELECT_H' => 'no',
		  'HAVE_SYS_SOCKET_H' => 'no',
		  'HAVE_SYS_STAT_H' => 1,
		  'HAVE_SYS_SYSTEMINFO_H' => 'no',
		  'HAVE_SYS_TIMEB_H' => 1,
		  'HAVE_SYS_TIME_H' => 'no',
		  'HAVE_SYS_TTOLD_H' => 'no',
		  'HAVE_SYS_TYPES_H' => 1,
		  'HAVE_SYS_UTIME_H' => 1,
		  'HAVE_SYS_UTSNAME_H' => 'no',
		  'HAVE_SYS_WAIT_H' => 'no',
		  'HAVE_T1LIB_H' => 'no',
		  'HAVE_TEMPNAM' => 1,
		  'HAVE_TERMCAP_H' => 'no',
		  'HAVE_TERMIOS_H' => 'no',
		  'HAVE_TERMIO_H' => 'no',
		  'HAVE_TERMLIB_H' => 'no',
		  'HAVE_TIMEZONE' => 1,
		  'HAVE_TIME_H' => 1,
		  'HAVE_TMPNAM' => 1,
		  'HAVE_TM_GMTOFF' => 'no',
		  'HAVE_TM_ZONE' => 'no',
		  'HAVE_TSEARCH' => 'no',
		  'HAVE_TTF_FORMATS' => 1,
		  'HAVE_TYPES_H' => 'no',
		  'HAVE_TZNAME' => 1,
		  'HAVE_TZSET' => 1,
		  'HAVE_ULLTOSTR' => 'no',
		  'HAVE_UNAME' => 'no',
		  'HAVE_UNISTD_H' => 'no',
		  'HAVE_UTIME_H' => 'no',
		  'HAVE_UTMPX_H' => 'no',
		  'HAVE_UT_HOST' => 'no',
		  'HAVE_VALUES_H' => 'no',
		  'HAVE_VARARGS_H' => 1,
		  'HAVE_VFORK_H' => 'no',
		  'HAVE_VPRINTF' => 1,
		  'HAVE_VSNPRINTF' => 1,
		  'HAVE_VSPRINTF' => 1,
		  'HAVE_WAITPID' => 'no',
		  'HAVE_WCHAR_H' => 1,
		  'HAVE_WCTYPE_H' => 1,
		  'HAVE_X11_XOSDEFS_H' => 'no',
		  'HAVE_X11_XPM_H' => 'no',
		  'HAVE_XBASENAME' => 1,
		  'HAVE_ZLIB' => 1,
		  'HAVE_ZLIB_COMPRESS2' => 1,
		  'HAVE_ZLIB_H' => 1,
		  'HAVE___ARGZ_COUNT' => 'no',
		  'HAVE___ARGZ_NEXT' => 'no',
		  'HAVE___ARGZ_STRINGIFY' => 'no',
		  'HP2627WIN' => 'no',
		  'HTEX' => 1,
		  'ICONV_CONST' => 'no',
		  'IPC' => 'no',
		  'KPATHSEA' => '1',
		  'KPSEVERSION' => '"kpathsea version ". look_for(KPSEVERSION, configure)',
		  'LDT1LIB' => 1,
		  'LOCALTIME_CACHE' => 'no',
		  'MAKE_FMT_BY_DEFAULT' => '1',
		  'MAKE_OMEGA_OCP_BY_DEFAULT' => '0',
		  'MAKE_OMEGA_OFM_BY_DEFAULT' => '0',
		  'MAKE_TEX_MF_BY_DEFAULT' => '1',
		  'MAKE_TEX_PK_BY_DEFAULT' => '1',
		  'MAKE_TEX_TEX_BY_DEFAULT' => '0',
		  'MAKE_TEX_TFM_BY_DEFAULT' => '1',
		  'MFTALKWIN' => 'no',
		  'MOTIF' => 'no',
		  'MSB2LSB' => 'no',
		  'NAMESPACE_TWEAKS' => 'no',
		  'NEED_SYS_TYPES_H' => 'no',
		  'NEXTWIN' => 'no',
		  'NICE_PRIORITY' => 'no',
		  'NLIST_NAME_UNION' => 'no',
		  'NLIST_STRUCT' => 'no',
		  'NOTOOL' => 1,
		  'NO_DUMP_SHARE' => 'no',
		  'NO_TEXT_SELECT' => 'no',
		  'OPI_SUPPORT' => 1,
		  'OS_TYPE' => 'Win32',
		  'PACKAGE' => 'look_for(PACKAGE, configure)',
		  'PRODUCT' => 'look_for(PRODUCT, configure)',
		  'PROTOTYPES' => 1,
		  'PS_DPS' => 'no',
		  'PS_GS' => 1,
		  'PS_NEWS' => 'no',
		  'REGISWIN' => 'no',
		  'RETSIGTYPE' => 'void',
		  'SELECT_TAKES_INT' => 'no',
		  'SETVBUF_REVERSED' => 'no',
		  'SIZEOF_INT' => 4,		 
		  'SIZEOF_LONG' => 4,		 
		  'SIZEOF_LONG_LONG' => '8',
		  'SMART_PUTENV' => 'no',
		  'SMART_PUTENV' => 'no',
		  'STACK_DIRECTION' => 'no',
		  'STATUSLINE' => 1,
		  'STAT_MACROS_BROKEN' => 'no',
		  'STDC_HEADERS' => 1,
		  'STRIP_DEBUG' => 'no',
		  'SUNOS4' => 'no',
		  'SUNWIN' => 'no',
		  'SVR4' => 'no',
		  'SYSTEM_XPDFRC' => 'no',
		  'T1LIB' => 1,
		  'TEKTRONIXWIN' => 'no',
		  'TERMIOS_NEEDS_XOPEN_SOURCE' => 'no',
		  'TIME_WITH_SYS_TIME' => 'no',
		  'TM_IN_SYS_TIME' => 'no',
		  'UMAX' => 'no',
		  'UMAX4_3' => 'no',
		  'UNITERMWIN' => 'no',
		  'USE_DIGEST' => 1,
		  'USE_GF' => 1,
		  'USE_GZIP' => 1,
		  'USE_OPIE' => 1,
		  'VERSION' => 'look_for(VERSION, configure)',
		  'WEB2CVERSION' =>'" (Web2c " . look_for(WEB2CVERSION, configure) . ")"',
		  'WINSIZE_IN_PTEM' => 'no',
		  'WITH_DMALLOC' => 'no',
		  'WORDS_BIGENDIAN' => 'no',
		  'X11WIN' => 'no',
		  'X_DISPLAY_MISSING' => 1,
		  'YYTEXT_CHAR' => 'no',
		  'YYTEXT_POINTER' => 1,
		  'YYTEXT_UCHAR' => 'no',
		  '_ALL_SOURCE' => 'no',
		  '_MINIX' => 'no',
		  '_POSIX_1_SOURCE' => 'no',
		  '_POSIX_SOURCE' => 'no',
		  '__CHAR_UNSIGNED__' => 'no',
		  'const' => 'const',
		  'getgroups' => 'no',
		  'gid_t' => 'int',
		  'inline' => '__inline',
		  'int32_t' => 'int',
		  'memcmp' => 'no',
		  'mktime' => 'no',
		  'off_t' => '_off_t',
		  'pid_t' => 'int',
		  'size_t' => 'no',
		  'strftime' => 'no',
		  'u_char' => 'unsigned char',
		  'u_int' => 'unsigned int',
		  'u_long' => 'unsigned long',
		  'u_short' => 'unsigned short',
		  'uid_t' => 'int',
		  'uint16_t' => 'unsigned short',
		  'uint32_t' => 'unsigned int',
		  'vfork' => 'no'
);

sub configure_cauto {
  local($src, $dst) = @_;
  local($in_comment);
  print STDERR "Doing $src -> $dst\n";

  open IN, "<$src";
  open OUT, ">$dst";
  $in_comment = 0;
  $in_cond = 0;
  $found_feature = 0;
  while (<IN>) {
    
    if ($_ =~ m@^#if.*(config|c.?auto).?h@io) {
      print OUT $_;
      next;
    }
    
    if ($_ =~ m@^#\s*(if|ifdef|ifndef)@ ) {
      $in_cond++;
      print OUT $_;
      next;
    }
    if ($_ =~ m@^#\s*endif@ ) {
      $in_cond--;
      print OUT $_;
      next;
    }

    if ($in_cond > 1 || ($in_cond == 1 && $found_feature != 0)) {
      print OUT $_;
      next;
    }

    if ($in_comment == 0 && $_ =~ m@^\s*/\*@) {
      $in_comment = 1;
    }
    if ($in_comment == 1) {
      print OUT $_;
      if ($_ =~ m@\*/\s*$@) {
	$in_comment = 0;
      }
      next;
    }
    if ($_ =~ m@#include\s*[<"]([^>"]*)[>"]@) {
	print STDERR "include $1 matched\n";
	if ($excludes{$1}) {
          next;
        }
        print OUT $_;
        next;
      }
    if ($_ =~ m@\#(define|undef)\s*([A-z0-9_-]+)@) {
      # Found some feature before #if
      if ($in_cond == 0) { 
	$found_feature = 1;
      }
      if ($have_features{$2} eq 'no') {
	print OUT "#undef $2\n";
	next;
      }
      # Warning : another match destroys previous $n .
      elsif ($2 eq "KPSEVERSION" || $2 eq "WEB2CVERSION") {
	  print OUT "#define $2 \"" . eval($have_features{$2}) . "\"\n";
	  next;
      }
      elsif ($2 eq "PACKAGE" || $2 eq "PRODUCT" || $2 eq "VERSION") {
	local ($value, $var);
	$var = $2;
	$value = eval ($have_features{$2});
	if ($value !~ m/\".*\"$/) {
	  $value = "\"$value\"";
	}
	print OUT "#define $var $value\n";
	  next;
      }
      elsif ($have_features{$2}) {
	print OUT "#define $2 " . $have_features{$2} . "\n";
	next;
      }
      elsif ($1 eq 'define') {
	print OUT $_;
	next;
      }
      else {
	print STDERR "Feature not matched : $2\n";
	print OUT $_;
	next;
      }
    }
    if ($_ =~ m@^\s*$@) {
      print OUT $_;
      next;
    }
    print STDERR "$_ : not matched\n";
  }
  close (IN);
  close (OUT);
}

