
require "newgetopt.pl";
use lib ("./perl");
use file_utils qw(dirname basename normalize walk_dir cleandir sort_uniq
		  copy remove_list push_uniq newer sync_dir build_path);
use Cwd;

$rootprj = "d:/source/TeXLive";
$p4rootprj = "//neveryon";
$subdir = "";
$dir = "";

&main;
0;

sub main {

  unless (&NGetOpt ("root_project=s", "subdir=s", "dry")) {
    print STDERR "Try `$0 --help'";
    exit 1;
  }

  if ($opt_root_project ne "") {
    if (-d $root_project) {
      $rootprj = $opt_root_project;
    }
    else {
      print STDERR "$0: $rootprj is not a directory, exiting...\n";
      exit 1;
    }
  }

  if ($opt_subdir ne "") {
    $subdir = $opt_subdir;
  }

  $dir = build_path($rootprj, $subdir);

  if (! -d $dir) {
    print STDERR "$0: $dir is not a directory, exiting...\n";
    exit 1;

  }

  $cwd = &getcwd;

  if ($opt_dry) {
    print STDERR "Changing directory for $dir\n";
    print STDERR "Executing \"dir /s /b /a-d | p4 -x - add\"\n";
    print STDERR "Changing directory for $cwd\n";
  }
  else {
    chdir($dir);
    system("dir /s /b /a-d | p4 -x - add");
    chdir ($cwd);
  }
  $dir = normalize($dir, "/");
  $dir =~ s/^$rootprj/$p4rootprj/;
  $dir = $dir . "/...";

  if ($opt_dry) {
    print STDERR "Executing \"p4 diff -sd $dir | p4 -x - delete\"\n";
    print STDERR "Executing \"p4 diff -se $dir | p4 -x - edit\"\n";
  }
  else {
    system("p4 diff -sd $dir | p4 -x - delete");
    system("p4 diff -se $dir | p4 -x - edit");
  }
}
