
require "newgetopt.pl";
use lib ("./perl");
use file_utils qw(dirname basename normalize walk_dir cleandir sort_uniq
		  copy remove_list push_uniq newer sync_dir build_path);
use Cwd;

$rootprj = "d:/source/TeXLive";
$p4rootprj = "//fabrice";
$win32srcdir = "d:/source/fptex/win32";
$win32texlive = "$rootprj/Build/source/TeX/win32";

@files = ( "convert.bat", "setvars.bat", "win32.mak");

@dirs = ( "cmdutils", "def", "expat", "geturl",
	  "include", "lib", "make", "perl", "rc",
	  "sed", "TeXLive", "TeXSetup", "unzip");

&main;
0;

sub main {

#    unless (&NGetOpt ("root_project=s", "subdir=s", "dry")) {
#      print STDERR "Try `$0 --help'";
#      exit 1;
#    }
  foreach $f (@files) {
    &copy("$win32srcdir/$f", "$win32texlive/$f");
  }
  foreach $d (@dirs) {
    &sync_dir("$win32srcdir/$d", "$win32texlive/$d");
  }

  $dir = build_path($rootprj, $subdir);

  if (! -d $dir) {
    print STDERR "$0: $dir is not a directory, exiting...\n";
    exit 1;

  }

  $dir = $win32texlive;

  $cwd = &getcwd;

  if ($opt_dry) {
    print STDERR "Changing directory for $dir\n";
    print STDERR "Executing \"dir /s /b /a-d | p4 -x - add\"\n";
    print STDERR "Changing directory for $cwd\n";
  }
  else {
    chdir($dir);
    system("dir /s /b /a-d | p4 -x - add");
    chdir ($cwd);
  }
  $dir = normalize($dir, "/");
  $dir =~ s/^$rootprj/$p4rootprj/;
  $dir = $dir . "/...";

  if ($opt_dry) {
    print STDERR "Executing \"p4 diff -sd $dir | p4 -x - delete\"\n";
    print STDERR "Executing \"p4 diff -se $dir | p4 -x - edit\"\n";
  }
  else {
    system("p4 diff -sd $dir | p4 -x - delete");
    system("p4 diff -se $dir | p4 -x - edit");
  }
}
